#package provide app-tkfind 1.0
#
# Bt@C폜c[ V1.20
# Copyright (C) 2004 Satoshi Imai
#

option add *Font {{lr SVbN} 9}

set topdir c:/
set filter Thumbs.db
set normal 1
set hidden 1
set hidden_dir 0

pack [frame .f1] -fill x
label .f1.ldir -text Tꏊ:
entry .f1.dir -textvariable topdir
button .f1.browse -text ... -command browse
checkbutton .f1.search -indicatoron no -padx 2 -pady 2 -text {  } \
	-textvariable search_label -variable search_flag \
	-onvalue 1 -offvalue 0 -command start
label .f1.lfilter -text tB^:
entry .f1.filter -textvariable filter
pack .f1.ldir -side left
pack .f1.dir -side left -fill x -expand 1
pack .f1.browse -side left
pack .f1.search -side left
pack .f1.lfilter -side left
pack .f1.filter -side left

pack [frame .f2] -anchor w
label .f2.lfile -text Ώ:
checkbutton .f2.normal -text ʂ̃t@C -variable normal
checkbutton .f2.hidden -text Bt@C -variable hidden
checkbutton .f2.hidden_dir -text BtH_ -variable hidden_dir
pack .f2.lfile .f2.normal .f2.hidden .f2.hidden_dir -side left

pack [frame .f3] -fill both -expand 1
listbox .f3.list -height 20 -width 80 -selectmode extended -listvar listvar \
	-yscroll {.f3.sv set} -xscroll {.f3.sh set}
scrollbar .f3.sv -command {.f3.list yview}
scrollbar .f3.sh -orient horizontal -command {.f3.list xview}
grid .f3.list -in .f3 -row 0 -column 0 -sticky nsew
grid .f3.sv -in .f3 -row 0 -column 1 -sticky ns
grid .f3.sh -sticky we
grid columnconfigure .f3 0 -weight 1
grid rowconfigure .f3 0 -weight 1

wm protocol . WM_DELETE_WINDOW {set stop 1; exit}

proc start {} {
	global listvar topdir search_label search_flag stop
	if {$search_flag == 0} {
		set stop 1
		set search_label {  }
		return
	}
	set search_label { ~ }
	set stop 0
	set listvar {}
	busy {find $topdir}
	set search_flag 0
	set search_label {  }
}

proc find {dir1} {
	global filter listvar stop normal hidden hidden_dir
	if {$stop == 1} {
		return
	}
	if {$normal == 1 && ![catch {glob -types f $dir1/$filter} files]} {
		foreach f $files {
			lappend listvar $f
			.f3.list see end
		}
	}
	if {$hidden == 1 && ![catch {glob -types {f hidden} $dir1/$filter} files]} {
		foreach f $files {
			lappend listvar $f
			.f3.list see end
		}
	}
	if {![catch {glob -types d $dir1/*} files]} {
		foreach dir2 $files {
			if {[lindex [file system $dir2] 0] != "tclvfs"} {
				find $dir2
			}
		}
	}
	if {$hidden_dir == 1 && ![catch {glob -types {d hidden} $dir1/*} files]} {
		foreach dir2 $files {
			if {[lindex [file system $dir2] 0] != "tclvfs"} {
				find $dir2
			}
		}
	}
	update
}

proc browse {} {
	global topdir
	set dir [tk_chooseDirectory -mustexist true]
	if {$dir != ""} {
		set topdir $dir
		.f1.dir xview end
		.f1.dir icursor end
	}
}

proc selectall {} {
	.f3.list selection set 0 end
}

proc delete {} {
	global listvar
	set id [.f3.list curselection]
	if {$id == ""} {
		return
	}
	set f [tk_messageBox -message "t@C폜܂H" -type okcancel -title t@C̍폜̊mF -icon question -default cancel]
	if {$f != "ok"} {
		return
	}
	set listvar_sav $listvar
	foreach id [.f3.list curselection] {
		set file [.f3.list get $id]
		file delete -force -- $file
		if {![file exists $file]} {
			set idx [lsearch $listvar_sav $file]
			if {$idx != -1} {
				set listvar_sav [lreplace $listvar_sav $idx $idx]
			}
		}
	}
	set listvar $listvar_sav
}

proc busy {body} {
	foreach child [winfo children .f3] {
	    set cursor(c$child) [$child cget -cursor]
	    $child configure -cursor watch
	}
	update
	uplevel 1 $body
	foreach child [winfo children .f3] {
	    $child configure -cursor $cursor(c$child)
	}
}

proc launch {} {
	global env
	set id [.f3.list curselection]
	if {$id == ""} {
		return
	}
	set file [.f3.list get $id]
	exec $env(COMSPEC) /c start $file
}

menu .popup -tearoff no
.popup add command -label "J" -command launch
.popup add separator
.popup add command -label "ׂđI" -accelerator "Ctrl+A" -command selectall
.popup add separator
.popup add command -label "폜" -accelerator "Del" -command delete

bind . <3> { tk_popup .popup %X %Y }
bind . <Delete> {delete}
bind . <Control-a> {selectall}
bind .f3.list <Double-1> {launch}

focus .f1.dir
.f1.dir icursor end
